poj 3422 Kaka's Matrix Travels (最大费用)

2024-04-29 13:38

本文主要是介绍poj 3422 Kaka's Matrix Travels (最大费用),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目链接:点击打开链接

Description

On an N × N chessboard with a non-negative number in each grid, Kaka starts his matrix travels with SUM = 0. For each travel, Kaka moves one rook from the left-upper grid to the right-bottom one, taking care that the rook moves only to the right or down. Kaka adds the number to SUM in each grid the rook visited, and replaces it with zero. It is not difficult to know the maximum SUM Kaka can obtain for his first travel. Now Kaka is wondering what is the maximum SUM he can obtain after his Kth travel. Note the SUM is accumulative during the K travels.

Input

The first line contains two integers N and K (1 ≤ N ≤ 50, 0 ≤ K ≤ 10) described above. The following N lines represents the matrix. You can assume the numbers in the matrix are no more than 1000.

Output

The maximum SUM Kaka can obtain after his Kth travel.

Sample Input

3 2
1 2 3
0 2 1
1 4 2

Sample Output

15

题目大意:

   给出一个矩阵,求只能向下或者向右的情况下能得到的最大和。一般的是指遍历一次,而这个是可以重复走K次。每经过一次后就把该点设为0.求最大和。


ps:这个题建图的时候需要拆点。每个格子都是一个点。把一个点拆成两个,两个点之间有两条路,一个容量为1,权值为那个格子的金钱数。另一条路容量为k-1,权值为0。因为走了一次钱捡起来之后就没钱了。


这个题有下面这一张图就够了:

 给出一个分析的很好的别人画的建图模型。


用堆建图,注意建图时费用取反 因为求的是最大费用 最后在乘-1就是要求的值了,开的数据大一点,5010回re,,

在记录最短路径时需要多看看,第一次这样用,第一次用异或求它的邻接点。。

//最大费用建边取反
#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<queue>
#define INF 0x3f3f3f3fusing namespace std;
///建图的
struct node
{int u,v,c,r,next;
}eage[50100];
int h[50100];
///存图 ,给一个点赋两个id,所谓的拆点
struct mode
{int id1,id2;int w;
} mp[550][550];
int S,T;
int top;int sum=0;
void add(int u,int v,int c,int r)
{eage[top].u=u;eage[top].v=v;eage[top].c=c;eage[top].r=r;eage[top].next=h[u];h[u]=top++;eage[top].u=v;eage[top].v=u;eage[top].c=0;///容量为0eage[top].r=-r;///费用相反eage[top].next=h[v];h[v]=top++;
}int dist[50100],vis[50100],pre[50100];bool spfa()
{//cout<<S<<T<<endl;return false;queue<int>q;while(!q.empty())q.pop();for(int i=0;i<=T;i++){dist[i]=INF;vis[i]=0;pre[i]=-1;}dist[0]=0;vis[0]=1;q.push(0);while(!q.empty()){int u=q.front();q.pop();vis[u]=0;for(int i=h[u];i!=-1;i=eage[i].next){//int u=eage[i].u;int v=eage[i].v;int c=eage[i].c;int r=eage[i].r;if(c&&dist[v]>dist[u]+r){dist[v]=dist[u]+r;pre[v]=i;///是记录的下标值if(!vis[v]){vis[v]=1;q.push(v);}}}}//cout<<dist[T]<<endl;// if(dist[T]!=INF)return true;if(pre[T]==-1)return false;return true;
}
void mimx()
{while(spfa()){//cout<<"@@@"<<endl;int mi=INF;for(int i=pre[T];i!=-1;i=pre[eage[i].u])///***{mi=min(mi,eage[i].c);}//cout<<mi<<"mi   d"<<endl<<endl;for(int i=pre[T];i!=-1;i=pre[eage[i].u]){eage[i].c-=mi;//int p=pre[eage[i].u];eage[i^1].c+=mi;///异或求邻接相反的点sum+=eage[i].r*mi;}}
}
int main()
{int n,k;while(~scanf("%d%d",&n,&k)){int cnt=0;S=0;T=n*n*2+1;int m=n*n;for(int i=1;i<=n;i++){for(int j=1;j<=n;j++){scanf("%d",&mp[i][j].w);mp[i][j].id1=++cnt;mp[i][j].id2=mp[i][j].id1+m;}}for(int i=0;i<=2*n*n+1;i++){h[i]=-1;}//cout<<"##"<<endl;///拆点建图top=0;sum=0;for(int i=1;i<=n;i++){for(int j=1;j<=n;j++){add( mp[i][j].id1,mp[i][j].id2,1,-mp[i][j].w);add( mp[i][j].id1,mp[i][j].id2,k-1,0);}}//cout<<"**"<<endl;///向右建图for(int i=1;i<=n;i++){for(int j=1;j<n;j++){add(mp[i][j].id2,mp[i][j+1].id1,k,0);}}///向下建图for(int i=1;i<n;i++){for(int j=1;j<=n;j++){add(mp[i][j].id2,mp[i+1][j].id1,k,0);}}add(0,mp[1][1].id1,k,0);add(mp[n][n].id2,T,k,0);//cout<<"!!!"<<endl;mimx();printf("%d\n",-sum);}return 0;}



这篇关于poj 3422 Kaka's Matrix Travels (最大费用)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/946245

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i